; -----------------------------------------------------------------------------
;    ⥫쭮 ਠ  
;  ୠ "६ ஭" N7,2006
; 	"ࠡ⪠ ணࠬ  P89LPC9xx"
;  ⥩	"ࠪ⨪ ணࠬ USB-ன"
; 		਩ 㭮, .
; -----------------------------------------------------------------------------
; icp.asm	ࠡ  ⮪ ICP
; -----------------------------------------------------------------------------
; ᮪ ᮢ
; -----------------------------------------------------------------------------
; _NOPS_		᪮쪮 権 nop
; _ICP_OUT_DATA_	뢮  設 
; _ICP_IN_DATA_		ਥ      
; -----------------------------------------------------------------------------
; ᮪ ணࠬ  ஢
; -----------------------------------------------------------------------------
; icpIn			   設 ICP
; icpOut		뢮   設 ICP
; icpEnterProg		室  ० ணࠬ஢
; icpPowerOff		⪫祭 ⠭
; icpResetMcu		१㧪 祭 ப஫
; -----------------------------------------------------------------------------
; ᮪ ணࠬ ᮪ ஢
; -----------------------------------------------------------------------------
; icpReadStatus		⥭    ⨢樨  BUSY	
; icpReadVersionId	⥭ ᨨ 
; icpMiscWriteFunc	 㦥 ଠ樨
; icpMiscReadFunc	⥭ 㦥 ଠ樨
; icpEraseSector	࠭ ᥪ
; icpErasePage		࠭ ࠭
; icpEraseGlobal	쭮 ࠭
; icpReadSectorCrc	⥭ ஫쭮 㬬 ᥪ
; icpReadGlobalCrc	⥭ 쭮 ஫쭮 㬬
; icpWriteCcp		 ⪨ 䨣樮 
; -----------------------------------------------------------------------------
; ⠭
; -----------------------------------------------------------------------------
; 祭 ᮮ⢥ 㬥
; P89LPC900 In-Circuit Programmind (ICP) Specifications.
;  ⮪ ICP
CMD_NOP		EQU 00h
WR_FMADRL	EQU 08h	;  襣  
RD_FMADRL	EQU 09h	; ⥭ 襣  
WR_FMADRH	EQU 0Ah ;  襣  
RD_FMADRH	EQU 0Bh	; ⥭ 襣  
WR_FMDATA	EQU 0Ch	;    ॣ FMDATA
RD_FMDATA	EQU 0Dh	; ⥭   ॣ FMDATA
WR_FMCON	EQU 0Eh	;    ॣ FMCON
RD_FMCON	EQU 0Fh	; ⥭  
WR_FMDATA_I	EQU 04h	;    ॣ FMDATA  ६
RD_FMDATA_I	EQU 05h	; ⥭   ॣ FMDATA  ६
WR_FMDATA_PG	EQU 14h	;    ॣ FMDATA  ६
RD_FMDATA_PG	EQU 15h	; ⥭   ॣ FMDATA  ६
;  樨   WR_FMCON
LOAD		EQU 00h	; 㧨  ॣ ࠭
PROG		EQU 48h	; ணࠬ஢ ࠭ (筨 ॣ ࠭)
ERS_G		EQU 72h	; 쭮 ࠭
ERS_S		EQU 71h	; ࠭ ᥪ
ERS_P		EQU 70h	; ࠭ ࠭
CONF		EQU 6Ch	;   㦥 ଠ樨
CRC_G		EQU 1Ah	; ᫨  ஫ 㬬
CRC_S		EQU 19h	; ᫨ ஫ 㬬 ᥪ
CCP		EQU 67h	;   䨣樨
; ⠢  
MASK_BUSY	EQU 80h	;   祭
BIT_BUSY	EQU 7
MASK_HVA	EQU 08h	; 殮 ணࠬ஢ 몫祭 譨 ᮡﬨ
BIT_HVA		EQU 3
MASK_HVE	EQU 04h ; 殮 ணࠬ஢  ନ஢
BIT_HVE		EQU 2
MASK_SV		EQU 02h	; 믮 樨 ஢ ᥪ ⮬
BIT_SV		EQU 1
MASK_OI		EQU 01h	;  ⠭
BIT_OI		EQU 0
; -----------------------------------------------------------------------------
; 砫 ᮢ
; -----------------------------------------------------------------------------
; _NOPS_		᪮쪮 権 nop
_NOPS_			MACRO
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ENDM
; _NOPS_ 


; _ICP_OUT_DATA_	뢮  設 
; 室
;	BYTE		
_ICP_OUT_DATA_		MACRO	BYTE
	mov a,BYTE
	lcall icpOut
	ENDM
; _ICP_OUT_DATA_ 


; _ICP_IN_DATA_		ਥ      
; 室
;	dptr		 
; ᪠ 
;	dptr
_ICP_IN_DATA_		MACRO
	lcall icpIn
	movx @dptr,a
	ENDM
; _ICP_IN_DATA_ 
; -----------------------------------------------------------------------------
;  ᮢ
; -----------------------------------------------------------------------------
; 砫 ணࠬ  ஢
; -----------------------------------------------------------------------------
; icpIn			   設 ICP
; 室
;	
; 室
;	a	ਭ⮥ 祭
; ᪠ 
;	c,cntIcp
icpIn:
	anl confIcp,#initIcpRead	; ணࠬ㥬   
	_NOPS_
	mov cntIcp,#8
icpI_1:	clr pinPcl
	_NOPS_
	setb pinPcl
	_NOPS_
	mov c,pinPda
	rrc a
	_NOPS_
	djnz cntIcp,icpI_1
	clr pinPcl
	_NOPS_
	ret
; icpIn 


; icpOut		뢮   設 ICP
; 室
;	a	। 祭
; 室
;	
; ᪠ 
;	a,c,cntIcp
icpOut:
	orl confIcp,#initIcpWrite	; ணࠬ㥬   뢮
	_NOPS_
	mov cntIcp,#8
icpO_1:	rrc a
	_NOPS_
	clr pinPcl
	mov pinPda,c
	_NOPS_
	setb pinPcl
	_NOPS_
	djnz cntIcp,icpO_1
	clr pinPcl
	_NOPS_
	ret
; icpOut 


; icpEnterProg		室  ० ணࠬ஢
; 室
;	
; 室
;	flagProgIcp	ਧ 室  ० ணࠬ஢
; ᪠ 
;	ea,cntIcp
icpEnterProg:
	clr flagProgIcp
	clr pinResetIcp
	clr pinPowerIcp
	clr pinPcl
	clr pinPda
	clr ea
	lcall usleep
	lcall usleep
	lcall usleep
	mov cntIcp,#7
icpEP_0:
	setb pinResetIcp
	lcall usleep
	clr pinResetIcp
	lcall usleep
	djnz cntIcp,icpEP_0
	setb pinResetIcp
	setb pinPda
	setb ea
	lcall usleep
	lcall usleep
	lcall usleep
	setb flagProgIcp	; ⠭ ਧ 室  ० ணࠬ஢
	ret
; icpEnterProg 


; icpPowerOff		⪫祭 ⠭
; 室
;	
; 室
;	flagProgIcp	ਧ 室  ० ணࠬ஢
; ᪠ 
;	
icpPowerOff:
	mov portIcp,#initPortIcp
	mov confIcp,#initConfIcp
	lcall usleep
	lcall usleep
	lcall usleep
	lcall usleep
	lcall usleep
	clr flagProgIcp		;  ਧ 室  ० ணࠬ஢
	ret
; icpPowerOff 


; icpResetMcu		१㧪 祭 ப஫
icpResetMcu:
	ret
; icpResetMcu 


; -----------------------------------------------------------------------------
;  ணࠬ  ஢
; -----------------------------------------------------------------------------
; 砫 ணࠬ ᮪ ஢
; -----------------------------------------------------------------------------
; icpReadStatus		⥭    ⨢樨  BUSY	
; 室
;	
; 室
;	a		0- 訡,  訡 - 祭  
; ᪠ 
;	a,c
icpReadStatus:
	lcall usleep
	_ICP_OUT_DATA_ #RD_FMCON
	lcall icpIn
	jnb acc.BIT_BUSY,icpRS_1	; ஢塞 襭 樨
	jb acc.BIT_HVA,icpRS_2
	jb acc.BIT_HVE,icpRS_2
	jb acc.BIT_SV,icpRS_2
	jb acc.BIT_OI,icpRS_2
	sjmp icpReadStatus		; த   ⢨ 訡
icpRS_1:
	clr a				; 訡 
icpRS_2:				; 室   訡
	ret
; icpReadStatus 


; icpReadVersionId	⥭ ᨨ 
icpReadVersionId:
	_MOVX_W_ EP0BUF,#0
	_MOVX_W_ EP0BUF+1,#1
	_MOVX_W_ EP0BUF+2,#0
	_MOVX_W_ EP0BUF+3,#0
	_MOVX_W_ EP0BUF+4,#'.'
	ret
; icpReadVersionId 


; icpMiscWriteFunc	 㦥 ଠ樨
icpMiscWriteFunc:
	ret
; icpMiscWriteFunc 


; icpMiscReadFunc	⥭ 㦥 ଠ樨
; 室
;	usbBufSetup	  묨  Setup 
;	flagStallEp0	ॡ ⠭ STALL  EP0 (   0)
; 室
;	flagStallEp0	ॡ ⠭ STALL  EP0 (1  訡)
;	EP0BUF		१ 襭 樨
;			ᥣ ᯥ
; ᪠ 
;	a,dptr
icpMiscReadFunc:
	jb flagProgIcp,icpMRF_1		; ᪫祭 ୮ 樠樨
	lcall icpEnterProg		; 室  ० ணࠬ஢
icpMRF_1:
	_ICP_OUT_DATA_ #WR_FMCON
	_ICP_OUT_DATA_ #CONF
	_ICP_OUT_DATA_ #WR_FMADRL
	_ICP_OUT_DATA_ usbBufSetup+wVL
	_ICP_OUT_DATA_ #RD_FMDATA
	mov dptr,#EP0BUF
	_ICP_IN_DATA_
	_MOVX_W_ EP0BUF+1,#'.'
	lcall icpPowerOff		; ⪫祭 ⠭
	ret
; icpMiscReadFunc 


; icpEraseSector	࠭ ᥪ
; 室
;	usbBufSetup	  묨  Setup 
;	flagStallEp0	ॡ ⠭ STALL  EP0 (   0)
; 室
;	flagStallEp0	ॡ ⠭ STALL  EP0 (1  訡)
;	EP0BUF		१ 襭 樨
;			 訡, ୥ 'X'
; ᪠ 
;	a,dptr
icpEraseSector:
	jb flagProgIcp,icpES_1		; ᪫祭 ୮ 樠樨
	lcall icpEnterProg		; 室  ० ணࠬ஢
icpES_1:
	_ICP_OUT_DATA_ #WR_FMADRH
	_ICP_OUT_DATA_ usbBufSetup+wVH
	_ICP_OUT_DATA_ #WR_FMCON
	_ICP_OUT_DATA_ #ERS_S
	lcall usleep			; প । ᮬ 
	lcall icpReadStatus
	jnz icpES_2			;  襭 १
	mov a,#'.'			; ᯥ譮 襭
	sjmp icpES_3
icpES_2:
	mov a,#'X'			; 襭  訡
icpES_3:
	mov dptr,#EP0BUF
	movx @dptr,a
	lcall icpPowerOff		; ⪫祭 ⠭
	ret
; icpEraseSector 


; icpErasePage		࠭ ࠭
icpErasePage:
	mov a,#'X'			; 襭  訡
	mov dptr,#EP0BUF
	movx @dptr,a
	ret
; icpErasePage 


; icpEraseGlobal	쭮 ࠭
icpEraseGlobal:
	ret
; icpEraseGlobal 


; icpReadSectorCrc	⥭ ஫쭮 㬬 ᥪ
icpReadSectorCrc:
	ret
; icpReadSectorCrc 


; icpReadGlobalCrc	⥭ 쭮 ஫쭮 㬬
icpReadGlobalCrc:
	ret
; icpReadGlobalCrc 


; icpWriteCcp		 ⪨ 䨣樮 
icpWriteCcp:
	ret
; icpWriteCcp 


; icp.asm 

