; -----------------------------------------------------------------------------
;    ⥫쭮 ਠ  
;  ୠ "६ ஭" N7,2006
; 	"ࠡ⪠ ணࠬ  P89LPC9xx"
;  ⥩	"ࠪ⨪ ணࠬ USB-ன"
; 		਩ 㭮, .
; -----------------------------------------------------------------------------
; isp.asm	ࠡ  ⮪ ISP
; -----------------------------------------------------------------------------
; ᮪ ᮢ
; -----------------------------------------------------------------------------
; _ISP_OUT_DATA_	뢮  設 ᨬ  ⢮ ࠧ
; _ISP_OUT_BYTE_	뢮  設 ᨬ 祭  
; _ISP_IN_DATA_		ਥ  ⢠ ᨬ    
; -----------------------------------------------------------------------------
; ᮪ ணࠬ  ஢
; -----------------------------------------------------------------------------
; ispInitUsart		樠 ᫥⥫쭮   ISP
; ispIn			   設 ISP
; ispOut		뢮   設 ISP
; ispOutCheck		뢮   設 ISP  ਥ ⢥
; ispEnterProg		室  ० ணࠬ஢
; ispPowerOff		몫祭 ⠭
; calcCrc		᫥ ஫쭮 㬬
; -----------------------------------------------------------------------------
; ᮪ ணࠬ ᮪ ஢
; -----------------------------------------------------------------------------
; ispWriteData		   FLASH-
; ispReadVersionId	⥭ ᨨ 
; ispMiscWriteFunc	 㦥 ଠ樨
; ispMiscReadFunc	⥭ 㦥 ଠ樨
; ispEraseSector	࠭ ᥪ
; ispErasePage		࠭ ࠭
; ispReadSectorCrc	⥭ ஫쭮 㬬 ᥪ
; ispReadGlobalCrc	⥭ 쭮 ஫쭮 㬬
; ispLoadBaudRate	㧪  USART
; ispResetMcu		१㧪 ப஫
; -----------------------------------------------------------------------------
; ⠭
; -----------------------------------------------------------------------------
; ଠ  ISP ᮮ⢥ 㬥
; User manual P89LPC920/921/922  8  2003
; -----------------------------------------------------------------------------
; 砫 ᮢ
; -----------------------------------------------------------------------------
; _ISP_OUT_DATA_	뢮  設 ᨬ  ⢮ ࠧ
; 室
;	BYTE		
;	DEAL		⢮ ।
;	LABEL		⪠  室  訡 뢮 ᨬ
_ISP_OUT_DATA_		MACRO	BYTE,DEAL,LABEL
	LOCAL	_IOD_
	IF DEAL > 1
	mov cntIsp,#DEAL
	ENDIF
	mov a,BYTE
_IOD_:	lcall ispOutCheck
	cjne a,BYTE,LABEL
	IF DEAL > 1
	djnz cntIsp,_IOD_
	ENDIF
	ENDM
; _ISP_OUT_DATA_ 


; _ISP_OUT_BYTE_	뢮  設 ᨬ 祭  
; 室
;	BYTE		
;	LABEL		⪠  室  訡 뢮 ᨬ
_ISP_OUT_BYTE_		MACRO	BYTE,LABEL
	mov a,BYTE
	swap a
	anl a,#0Fh
	lcall binToAscii
	_ISP_OUT_DATA_ b,1,LABEL
	mov a,BYTE
	anl a,#0Fh
	lcall binToAscii
	_ISP_OUT_DATA_ b,1,LABEL
	ENDM
; _ISP_OUT_BYTE_ 


; _ISP_IN_DATA_		ਥ  ⢠ ᨬ    
; 室
;	DEAL		⢮ 
;	PTRBUF		㪠⥫   
_ISP_IN_DATA_		MACRO	DEAL,PTRBUF
	LOCAL	_IID_
	IF DEAL > 1
	mov cntIsp,#DEAL
	ENDIF
_IID_:	lcall ispIn
	mov @PTRBUF,a
	IF DEAL > 1
	inc PTRBUF
	djnz cntIsp,_IID_
	ENDIF
	ENDM
; _ISP_IN_DATA_ 
; -----------------------------------------------------------------------------
;  ᮢ
; -----------------------------------------------------------------------------
; 砫 ணࠬ  ஢
; -----------------------------------------------------------------------------

; ispInitUsart		樠 ᫥⥫쭮   ISP
; 室
;	
; 室
;	
; ᪠ 
;	
ispInitUsart:
	mov th1,#0B2h
	mov tl1,#0B2h
	mov tmod,#20h	; CT = 0, MODE = 2
	mov a,ckcon
	setb acc.4
	mov ckcon,a	; T1M = 1
	mov a,pcon
	setb acc.7
	mov pcon,a	; SMOD = 1
	setb tr1
	mov scon0,#58h
	ret
; ispInitUsart 


; ispIn			   設 ISP
; 室
;	
; 室
;	a	ਭ⮥ 祭
; ᪠ 
;	
ispIn:
	jnb ri_0,ispIn	;  室 
	mov a,sbuf0
	clr ri_0
	ret
; ispIn 


; ispOut		뢮   設 ISP
; 室
;	a	। 祭
; 室
;	
; ᪠ 
;	
ispOut:
	mov sbuf0,a
	jnb ti_0,$	;  襭 ।
	clr ti_0
	ret
; ispOut 


; ispOutCheck		뢮   設 ISP  ਥ ⢥
; 室
;	a	। 祭
; 室
;	a	祭 ⢥
; ᪠ 
;	
ispOutCheck:
	lcall ispOut
	lcall ispIn
	ret
; ispOutCheck 


ispClearSbuf:
	mov cntIsp,#10
ispCS_2:
	lcall usleep
	lcall usleep
	lcall usleep
	lcall usleep
	lcall usleep
	jnb ri_0,ispCS_1
	clr ri_0
ispCS_1:
	djnz cntIsp,ispCS_2
	ret


; ispEnterProg		室  ० ணࠬ஢
; 室
;	
; 室
;	flagProgIsp	ਧ 室  ० ணࠬ஢
; ᪠ 
;	ea,cntIsp
ispEnterProg:
	clr flagProgIsp
	clr pinResetIsp
	clr pinPowerIsp
	clr ea
	lcall usleep
	lcall usleep
	lcall usleep
	mov cntIsp,#3
ispEP_1:
	setb pinResetIsp
	lcall usleep
	clr pinResetIsp
	lcall usleep
	djnz cntIsp,ispEP_1
	setb pinResetIsp
	lcall ispInitUsart
	lcall usleep
	setb ea
	mov cntIsp,#40		;  ⢮ ⮪
ispEP_3:
	mov sbuf0,#'U'
	jnb ti_0,$
	clr ti_0
	mov cntWait,#0
ispEP_4:
	lcall usleep
	lcall usleep
	lcall usleep
	lcall usleep
	lcall usleep
	djnz cntWait,ispEP_4
	jnb ri_0,ispEP_2
	clr ri_0
	mov b,sbuf0
	mov a,b
	cjne a,#'U',ispEP_2
	setb flagProgIsp	; ⠭ ਧ 室  ० ணࠬ஢
	lcall ispClearSbuf
	ret
ispEP_2:
	djnz cntIsp,ispEP_3
	ret
; ispEnterProg 


; ispPowerOff		몫祭 ⠭
; 室
;	
; 室
;	flagProgIsp	ਧ 室  ० ணࠬ஢
; ᪠ 
;	
ispPowerOff:
	clr tr1
	mov scon0,#40h
	lcall usleep
	lcall usleep
	lcall usleep
	mov portIsp,#initPortIsp
	mov confIsp,#initConfIsp
	lcall usleep
	lcall usleep
	lcall usleep
	lcall usleep
	lcall usleep
	clr flagProgIsp		;  ਧ 室  ० ணࠬ஢
	ret
; ispPowerOff 


; calcCrc		᫥ ஫쭮 㬬
; 室
;	crcIsp		⥪ ஫쭠 㬬
;	a		祭    
; 室
;	crcIsp		 ஫쭠 㬬
; ᪠ 
;	c
calcCrc:
	xch a,crcIsp
	clr c
	subb a,crcIsp
	xch a,crcIsp
	ret
; calcCrc 


; -----------------------------------------------------------------------------
;  ணࠬ  ஢
; -----------------------------------------------------------------------------
; 砫 ணࠬ ᮪ ஢
; -----------------------------------------------------------------------------

; ispWriteData		   FLASH-
ispWriteData:
	ret
; ispWriteData 


; ispReadVersionId	⥭ ᨨ 
; 室
;	flagStallEp0	ॡ ⠭ STALL  EP0 (   0)
; 室
;	flagStallEp0	ॡ ⠭ STALL  EP0 (1  訡)
;	EP0BUF		ਭ 
; ᪠ 
;	a,dptr
ispReadVersionId:
	jb flagProgIsp,ispRVI_1
	lcall ispEnterProg
	jb flagProgIsp,ispRVI_1
ispRVI_2:
	setb flagStallEp0
	ajmp ispRVI_3
ispRVI_1:				; ।  ':00000001FF'
	_ISP_OUT_DATA_ #':',1,ispRVI_2	; ':'
	_ISP_OUT_DATA_ #'0',7,ispRVI_2	; '0000000'
	_ISP_OUT_DATA_ #'1',1,ispRVI_2	; '1'
	_ISP_OUT_DATA_ #'F',2,ispRVI_2	; 'FF'
	mov _ptrDest,#ispBufLocal
	_ISP_IN_DATA_ 7,_ptrDest		; ਭ ଠ
ispRVI_3:
	lcall ispPowerOff
	ret
; ispReadVersionId 


; ispMiscWriteFunc	 㦥 ଠ樨
ispMiscWriteFunc:
	ret
; ispMiscWriteFunc 


; ispMiscReadFunc	⥭ 㦥 ଠ樨
; 室
;	usbBufSetup	  묨  Setup 
;	flagStallEp0	ॡ ⠭ STALL  EP0 (   0)
; 室
;	flagStallEp0	ॡ ⠭ STALL  EP0 (1  訡)
;	EP0BUF		१ 襭 樨
; ᪠ 
;	a,dptr,_ptrDest,_ptrSrc
ispMiscReadFunc:
	jb flagProgIsp,ispMRF_1
	lcall ispEnterProg
	jb flagProgIsp,ispMRF_1
	setb flagStallEp0		; ⪠  室  ० ணࠬ஢
	ljmp ispMRF_2
ispMRF_3:
	_MOVX_W_ EP0BUF+1,#'X'		; 訡  । 
	ljmp ispMRF_2
ispMRF_1:				; ।  ':01000003AACC'
	_ISP_OUT_DATA_ #':',1,ispMRF_3	; ':'
	_ISP_OUT_DATA_ #'0',1,ispMRF_3	; '0'
	_ISP_OUT_DATA_ #'1',1,ispMRF_3	; '1'
	_ISP_OUT_DATA_ #'0',5,ispMRF_3	; '00000'
	_ISP_OUT_DATA_ #'3',1,ispMRF_3	; '3'
	_ISP_OUT_BYTE_ usbBufSetup+wVL,ispMRF_3	; AA
	mov crcIsp,#0FCh
	mov a,usbBufSetup+wVL
	lcall calcCrc
	_ISP_OUT_BYTE_ crcIsp,ispMRF_3	; CC
	mov _ptrDest,#ispBufLocal
	_ISP_IN_DATA_ 5,_ptrDest	; ਭ ଠ
	mov _ptrSrc,#ispBufLocal	;  室 
	mov dptr,#EP0BUF		;  室 
	mov cntCode,#2			; ⢮ ᨬ  ८ࠧ
	lcall asciiToBinExt		; ८ࠧ   
	_MOVX_W_ EP0BUF+1,#'.'
ispMRF_2:
	lcall ispPowerOff		; ⪫祭 ⠭
	ret
; ispMiscReadFunc 


; ispEraseSector	࠭ ᥪ
; 室
;	usbBufSetup	  묨  Setup 
;	flagStallEp0	ॡ ⠭ STALL  EP0 (   0)
; 室
;	flagStallEp0	ॡ ⠭ STALL  EP0 (1  訡)
;	EP0BUF		१ 襭 樨
; ᪠ 
;	a,dptr,_ptrDest,_ptrSrc
ispEraseSector:
	jb flagProgIsp,ispES_1
	lcall ispEnterProg
	jb flagProgIsp,ispES_1
	setb flagStallEp0		; ⪠  室  ० ணࠬ஢
	ljmp ispES_2
ispES_3:
	_MOVX_W_ EP0BUF+1,#'X'		; 訡  । 
	ljmp ispES_2
ispES_1:				; ।  ':0300000401HHLLCC'
	_ISP_OUT_DATA_ #':',1,ispES_3	; ':'
	_ISP_OUT_DATA_ #'0',1,ispES_3	; '0'
	_ISP_OUT_DATA_ #'3',1,ispES_3	; '3'
	_ISP_OUT_DATA_ #'0',5,ispES_3	; '00000'
	_ISP_OUT_DATA_ #'4',1,ispES_3	; '4'
	_ISP_OUT_DATA_ #'0',1,ispES_3	; '0'
	_ISP_OUT_DATA_ #'1',1,ispES_3	; '1'
	_ISP_OUT_BYTE_ usbBufSetup+wVH,ispES_3	; HH
	_ISP_OUT_BYTE_ usbBufSetup+wVL,ispES_4	; LL
	sjmp ispES_5
ispES_4:
	ljmp ispES_3
ispES_5:
	mov crcIsp,#0F8h
	mov a,usbBufSetup+wVH
	lcall calcCrc
	mov a,usbBufSetup+wVL
	lcall calcCrc
	_ISP_OUT_BYTE_ crcIsp,ispES_4	; CC
	mov _ptrDest,#ispBufLocal
	_ISP_IN_DATA_ 3,_ptrDest	; ਭ ଠ
	mov _ptrDest,#ispBufLocal	;  室 
	mov dptr,#EP0BUF		;  室 
	mov a,@_ptrDest			; 롮ઠ ⢥⭮ ᨬ
	movx @dptr,a			; ࠭  । 
ispES_2:
	lcall ispPowerOff		; ⪫祭 ⠭
	ret
; ispEraseSector 


; ispErasePage		࠭ ࠭
ispErasePage:
	ret
; ispErasePage 


; ispReadSectorCrc	⥭ ஫쭮 㬬 ᥪ
ispReadSectorCrc:
	ret
; ispReadSectorCrc 


; ispReadGlobalCrc	⥭ 쭮 ஫쭮 㬬
ispReadGlobalCrc:
	ret
; ispReadGlobalCrc 


; ispLoadBaudRate	㧪  USART
ispLoadBaudRate:
	ret
; ispLoadBaudRate 


; ispResetMcu		१㧪 ப஫
ispResetMcu:
	ret
; ispResetMcu 


; isp.asm 

